#include "schedule.h"
#include "mc6847.h"


#define WRUPDATE	(1000)	/* xXVԊu(ms) */


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
cSche::cSche( void )
{
	for( int i=0; i<MAXEVENT; i++ ){
		ev[i].device = NULL;
		ev[i].Active = FALSE;
	}
	MasterClock = CPU_CLOCK;
	
	NextEvent  = -1;
	SaveCloclk = 0;
	
	WRClock    = 0;
	WRClockTmp = 0;
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
cSche::~cSche( void ){}


////////////////////////////////////////////////////////////////
// Cxg
//
// :	dev			CxgfoCXIuWFNg|C^
//			id			CxgID
// Ԓl:	evinfo *	Cxg|C^(݂ȂNULL)
////////////////////////////////////////////////////////////////
cSche::evinfo *cSche::Find( P6DEVENT *dev, int id )
{
	for( int i=0; i<MAXEVENT; i++ )
		if( ev[i].device == dev && ev[i].id == id ) return &ev[i];
	
	return NULL;
}


////////////////////////////////////////////////////////////////
// }X^NbNݒ
//
// :	clock	}X^NbN
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void cSche::SetMasterClock( int clock )
{
	MasterClock = clock;
	for( int i=0; i<MAXEVENT; i++ )
		if( ev[i].device && ev[i].nps > 0 && ev[i].Period > 0 ){
			ev[i].Period = (int)((double)clock / ev[i].nps);
			if( ev[i].Period < 1 ) ev[i].Period = 1;
		}

}


////////////////////////////////////////////////////////////////
// Cxgǉ
//
// :	dev		CxgfoCXIuWFNg|C^
//			id		CxgID
//			hz		Cxgg
//			loop	[vw TRUE:[v FALSE:^C
//			flag	CxgX^Cw
//				bit0  : JԂw 0:^C 1:[v
//				bit2,3,4: wP 000:Hz 001:us 010:ms 100:CPUXe[g
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL cSche::Add( P6DEVENT *dev, int id, double hz, int flag )
{
	// o^ς݂̏ꍇ͈U폜čēo^
	evinfo *e = Find( dev, id );
	if( e ) Del( e->device, e->id );
	
	for( int i=0; i<MAXEVENT; i++ ){
		if( !ev[i].device ){
			ev[i].device = dev;
			ev[i].id     = id;
			ev[i].Active = TRUE;
			
			// Cxgg̐ݒ
			switch( flag&(EV_US|EV_MS|EV_STATE) ){
			case EV_US:		// usŎw
				ev[i].nps    = (double)1000000 / hz;
				ev[i].Clock  = (int)((double)MasterClock / ev[i].nps);
				break;
			case EV_MS:		// msŎw
				ev[i].nps    = (double)1000 / hz;
				ev[i].Clock  = (int)((double)MasterClock / ev[i].nps);
				break;
			case EV_STATE:	// CPUXe[gŎw
				ev[i].nps    = (double)MasterClock / hz;
				ev[i].Clock  = (int)hz;
				break;
			default:		// HzŎw
				ev[i].nps    = hz;
				ev[i].Clock  = (int)((double)MasterClock / hz);
			}
			
			// ̐ݒ
			if( flag&EV_LOOP ){	// [vCxg
				ev[i].Period = ev[i].Clock;
				if( ev[i].Period < 1 ) ev[i].Period = 1;
			}else				// ^CCxg
				ev[i].Period = 0;
			
			// ̃Cxg܂ł̃NbNXV
			if( NextEvent < 0 ) NextEvent = ev[i].Clock;
			else                NextEvent = min( NextEvent, ev[i].Clock );
			
			return TRUE;
		}
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// Cxg폜
//
// :	dev		CxgfoCXIuWFNg|C^
//			id		CxgID
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL cSche::Del( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	if( e ){
		e->device = NULL;
		e->Active = FALSE;
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// Cxggݒ
//
// :	dev		CxgfoCXIuWFNg|C^
//			id		CxgID
//			hz		Cxgg
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL cSche::SetHz( P6DEVENT *dev, int id, double hz )
{
	evinfo *e = Find( dev, id );
	if( e ){
		e->nps    = hz;
		e->Period = (int)((double)MasterClock / hz);
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// CxgXV
//
// :	clk		i߂NbN
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void cSche::Update( int clk )
{
	// NbN𗭂ߍ
	SaveCloclk += clk;	// ̃Cxgp
	WRClockTmp += clk;	// sxvZp
	
	// ̃CxgNbNɒBĂȂ߂
	//  clk=0 ̏ꍇ͍XVs
	if( NextEvent > SaveCloclk && clk ) return;
	NextEvent = -1;
	
	int cnt;
	do{
		cnt = 0;
		for( int i=0; i<MAXEVENT; i++ ){
			// LȃCxg?
			if( ev[i].Active ){
				ev[i].Clock -= SaveCloclk;
				// XVԊuꍇ͕񔭐\
				// Ƃ肠SĂȂ܂ŌJԂĂƂł̂?
				if( ev[i].Clock <= 0 ){
					// CxgR[obNs
					ev[i].device->EventCallback( ev[i].id, ev[i].Clock );
					
					if( ev[i].Period > 0 ){	// [vCxg
						ev[i].Clock += ev[i].Period;
						if( ev[i].Clock <= 0 ) cnt++;	// ̃CxgĂJEg
					}else{					// ^CCxg
						Del( ev[i].device, ev[i].id );
						break;
					}
				}
				// ̃Cxg܂ł̃NbNXV
				if( NextEvent < 0 ) NextEvent = ev[i].Clock;
				else                NextEvent = min( NextEvent, ev[i].Clock );
			}
		}
		SaveCloclk = 0;
	}while( cnt > 0 );
}


////////////////////////////////////////////////////////////////
// wCxgZbg
//
// :	dev		CxgfoCXIuWFNg|C^
//			id		CxgID
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void cSche::Reset( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	if( e ){
		// ߍ񂾃NbNl
		e->Clock = e->Period + SaveCloclk;
	}
}


////////////////////////////////////////////////////////////////
// Cxg܂ł̎cNbN߂
//
// :	dev		CxgfoCXIuWFNg|C^
//			id		CxgID
// Ԓl:	int		cXe[g(IDȂ0)
////////////////////////////////////////////////////////////////
int cSche::Rest( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	if( e ) return e->Clock;
	else    return 0;
}


////////////////////////////////////////////////////////////////
// Cxg̐is߂
//
// :	dev		CxgfoCXIuWFNg|C^
//			id		CxgID
// Ԓl:	double	Cxgis(1.0100%)
////////////////////////////////////////////////////////////////
double cSche::Scale( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	// Cxg݂1̃NbNݒ肳Ă?
	if( e && e->Period > 0 ){
		// ߍ񂾃NbNl
		double sc = (double)( (double)( e->Period - e->Clock + SaveCloclk ) / (double)e->Period );
		return min( max( 0.0, sc ), 1.0 );
	}else
		return 0;
}


////////////////////////////////////////////////////////////////
// Cxg擾
//
// :	evinfo *	Cxg\̂ւ̃|C^(device,id ZbgĂ)
// Ԓl:	BOOL		TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL cSche::GetEvinfo( evinfo *info )
{
	if( !info ) return FALSE;
	
	evinfo *e = Find( info->device, info->id );
	if( e ){
		info->Active = e->Active;
		info->Period = e->Period;
		info->Clock  = e->Clock;
		info->nps    = e->nps;
		return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// Cxgݒ
//
// :	evinfo *	Cxg\̂ւ̃|C^
// Ԓl:	BOOL		TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL cSche::SetEvinfo( evinfo *info )
{
	if( !info ) return FALSE;
	
	// ⓚpŒǉ
	if( !Add( info->device, info->id, 1, EV_HZ ) ) return FALSE;
	
	evinfo *e = Find( info->device, info->id );
	if( e ){
		e->Active = info->Active;
		e->Period = info->Period;
		e->Clock  = info->Clock;
		e->nps    = info->nps;
		return TRUE;
	}
	return FALSE;
}






////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
SCH6::SCH6( VM6 *vm, const P6ID& id ) : P6DEVICE(vm,id)
{
	CpuClock   = CPU_CLOCK;
	WaitEnable = TRUE;
	VSYNC      = FALSE;
	
	// Z}tH쐬
	WaitSem = SDL_CreateSemaphore( 0 );
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
SCH6::~SCH6( void )
{
	// ~
	Stop();
	
	// Z}tHJ
	if( WaitSem ) SDL_DestroySemaphore( WaitSem );

}


////////////////////////////////////////////////////////////////
// Xbh֐(I[o[Ch)
//   SDL_Delay()̐xɍÊł
//   49.7ȏAғOSł͕s邯ǁDDDł
//
// :	inst	g̃IuWFNg|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SCH6::OnThread( void *inst )
{
	SCH6 *ti;
	int Vint[VSYNC_HZ];
	int VintCnt = 0;
	DWORD now,last;
	
	EnableScrUpdate = 0;
	
	ti = (SCH6 *)inst;	// g̃IuWFNg|C^擾
	
	// 1bԂ̃C^[oݒ
	for( int i=0; i<VSYNC_HZ; i++ ) Vint[i] = (int)( 1000 / VSYNC_HZ );
	int Vrem = 1000 - (int)( 1000 / VSYNC_HZ ) * VSYNC_HZ;
	for( int i=0; i<Vrem; i++ ) Vint[(int)(VSYNC_HZ * i / Vrem)]++;
	
	// ŏ̑҂Ԃݒ
	now  = SDL_GetTicks();
	last = now;
	DWORD NextWait = now + Vint[VintCnt++];
	
	while( !this->SThread::IsCancel() ){
		now = SDL_GetTicks();
		if( now >= NextWait ){
			NextWait += Vint[VintCnt++];
			if( VintCnt >= VSYNC_HZ ) VintCnt -= VSYNC_HZ;
			ti->WaitReset();
		}else
			SDL_Delay( 1 );
		
		if( now - last >= WRUPDATE ){
			WRClock     = WRClockTmp;
			WRClockTmp  = 0;
			last       += WRUPDATE;
		}
	}
}


////////////////////////////////////////////////////////////////
// Jn
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
BOOL SCH6::Start( void )
{
	// Xbh
	if( !this->SThread::BeginThread( this ) ) return FALSE;
	this->SThread::Start();
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ~
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SCH6::Stop( void )
{
	this->SThread::Cancel();	// XbhItOĂ
	this->SThread::Waiting();	// XbhI܂ő҂
}


////////////////////////////////////////////////////////////////
// WaitLtO擾
//
// :	Ȃ
// Ԓl:	L:TRUE :FALSE
////////////////////////////////////////////////////////////////
BOOL SCH6::GetWaitEnable( void )
{
	return WaitEnable;
}


////////////////////////////////////////////////////////////////
// WaitLtOݒ
//
// :	WaitLtO L:TRUE :FALSE
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SCH6::SetWaitEnable( BOOL we )
{
	WaitEnable = we;
}


////////////////////////////////////////////////////////////////
// VSYNC Wait
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SCH6::VWait( void )
{
	if( vm->IsWaitEnable() ) SDL_SemWait( WaitSem );
	VSYNC = FALSE;
}


////////////////////////////////////////////////////////////////
// Wait
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SCH6::WaitReset( void )
{
	if( !SDL_SemValue( WaitSem ) ) SDL_SemPost( WaitSem );
	
	// ʍXVtO𗧂Ă
	EnableScrUpdate++;
}


////////////////////////////////////////////////////////////////
// 
//
// :	clock	CPUNbN(Hz)
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL SCH6::Init( int clock )
{
	// Z}tH`FbN
	if( !WaitSem ) return FALSE;
	
	// CPUNbNݒ
	CpuClock = clock;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ** ǎgȂȂ܂ **
// ʂ̕\ԂɉCPUXe[gvZ
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
// PC-6001mk2SR̃}jAp (ȂSR? ܂܎茳ɂꂵȂ)

// \g
//  15.70kHz(63.70usec)
//  59.92 Hz(16.69msec)

// ^C~O (P:usec)
// \[h  obN|[` \ tg|[`  v
// 32		4.87	13.74		35.76		9.33		63.70
// 40,80	4.87	 9.27		44.69		4.86		63.69

// ^C~O (P:msec)
// \[h  obN|[` \ tg|[`  v
// 192H			0.25	 2.49		12.23		1.72		16.69
// 200H			0.25	 2.23		12.74		1.47		16.69
// 204H			0.25	 2.11		12.99		1.34		16.69

// hbgNbN,CŒu
// ^C~O
// \[h  obN|[` \ tg|[`  v
// 32		34			98			256		67			455
// 40,80	34	 		66			320		35			455

// ^C~O
// \[h  obN|[` \ tg|[`  v
// 192H			3			34			192		33			262
// 200H			3		 	30			200		29			262
// 204H			4(?)		33			204		21			262


// ܂Ƃ߂ƂȊ
// g[^   455 Clk (hbgNbN 7.16MHz? 3.58MHz̗GbW?)
// \       256 320 Clk
// \     199 135 Clk
// g[^C 262 Line
// \C     192 200 204 Line
// \C    70  62  58 Line

// [\]̂CPU~ƍlƁCғ͂Ȋ
// łSR͂ȂɎ~܂Ȃ炵
// N60   : 58.769% ( 199*192 + 455*70 ) / ( 262*455 )
// N60m  : 46.313% ( 135*200 + 455*62 ) / ( 262*455 )
// N66SR : 45.239% ( 135*204 + 455*58 ) / ( 262*455 )

// CPUNbNōl
// CPUNbN/s      3993600
// CPUNbN/VSYNC    66560 (VSYNC:60HzƂ)
// CPUNbN/1Line     1109 (66560/262)
//   ғ:~/1Line  486:623 331:778
// CPUNbN/VBlank  146368  155240

/*
#define	Ref1	(double)( (double)( 199*192 + 455*70 ) / (double)( 262*455 ) )
#define	Ref2	(double)( (double)( 135*200 + 455*62 ) / (double)( 262*455 ) )

void SCH6::CalcCpuState( void )
{
	BOOL disp = vm->vdg->GetCrtDisp();
	BOOL win  = vm->vdg->GetWinSize();
	
	// 1b̃Xe[g߂
	int CpuState;
	if( disp ) CpuState = (int)( (win ? Ref1 : Ref2) * (double)CpuClock );
	else       CpuState = CpuClock;

CpuState = CpuClock;
	
	// ̂܂܂Ƒ̂œKɒ
//	CpuState = CpuState * 86 / 100;
	
	// }X^NbNݒ
	cSche::SetMasterClock( CpuState );
}
*/


////////////////////////////////////////////////////////////////
// sx擾
//
// :	Ȃ
// Ԓl:	int		sx(%)({100)
////////////////////////////////////////////////////////////////
int SCH6::GetRatio( void )
{
	return (int)(double)( WRClock * 100.0 / MasterClock * 1000.0 / WRUPDATE + 0.5 );
}


////////////////////////////////////////////////////////////////
// ʍXV}?
//
// :	Ȃ
// Ԓl:	BOOL		TRUE:XV FALSE:XVȂ
////////////////////////////////////////////////////////////////
BOOL SCH6::IsScreenUpdate( void )
{
	if( EnableScrUpdate ){
		EnableScrUpdate--;
		return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ǂłSAVE
//
// :	Ini		INIIuWFNg|C^
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL SCH6::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "SCHEDULE", NULL, "MasterClock",	"%d",	MasterClock );
	Ini->PutEntry( "SCHEDULE", NULL, "CpuClock",	"%d",	CpuClock );
	Ini->PutEntry( "SCHEDULE", NULL, "VSYNC",		"%s",	VSYNC ? "Yes" : "No" );
	Ini->PutEntry( "SCHEDULE", NULL, "NextEvent",	"%d",	NextEvent );
	Ini->PutEntry( "SCHEDULE", NULL, "SaveCloclk",	"%d",	SaveCloclk );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ǂłLOAD
//
// :	Ini		INIIuWFNg|C^
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL SCH6::DokoLoad( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	// SẴCxgЂƂ܂ɂ
	// Cxg͊eW[ɍĐݒ肷
	for( int i=0; i<MAXEVENT; i++ ){
		ev[i].device = NULL;
		ev[i].Active = FALSE;
	}
	
	Ini->GetInt(    "SCHEDULE", "MasterClock",	&MasterClock,	MasterClock );
	Ini->GetInt(    "SCHEDULE", "CpuClock",		&CpuClock,		CpuClock );
	Ini->GetTruth(  "SCHEDULE", "VSYNC",		&VSYNC, 		VSYNC );
	Ini->GetInt(    "SCHEDULE", "NextEvent",	&NextEvent,		NextEvent );	// CxgĐݒ莞ɍČ?
	Ini->GetInt(    "SCHEDULE", "SaveCloclk",	&SaveCloclk,	SaveCloclk );
	
	return TRUE;
}
